diff -crBPN --exclude=wp-config.php --exclude=wordpress.sql --exclude=.htaccess-dist --exclude=wp-cache-config.php --exclude=htaccess-dist --exclude=wp-config.php --exclude=wordpress.sql --exclude=wp-cache-config.php --exclude=editor_plugin.js --exclude=jetpack --exclude=.files.list --exclude=wordpress-3.6.pl /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/formatting.php /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/formatting.php
*** /home/packages/code/qi/SOURCES/wordpress-3.5.2/wp-includes/formatting.php	2013-06-19 17:12:36.000000000 -0500
--- /home/packages/code/qi/SOURCES/wordpress-3.6/wp-includes/formatting.php	2013-07-16 12:44:42.000000000 -0500
***************
*** 5,11 ****
   * Handles many functions for formatting output.
   *
   * @package WordPress
!  **/
  
  /**
   * Replaces common plain text characters into formatted entities
--- 5,11 ----
   * Handles many functions for formatting output.
   *
   * @package WordPress
!  */
  
  /**
   * Replaces common plain text characters into formatted entities
***************
*** 134,141 ****
   * Search for disabled element tags. Push element to stack on tag open and pop
   * on tag close. Assumes first character of $text is tag opening.
   *
-  * @access private
   * @since 2.9.0
   *
   * @param string $text Text to check. First character is assumed to be $opening
   * @param array $stack Array used as stack of opened tag elements
--- 134,141 ----
   * Search for disabled element tags. Push element to stack on tag open and pop
   * on tag close. Assumes first character of $text is tag opening.
   *
   * @since 2.9.0
+  * @access private
   *
   * @param string $text Text to check. First character is assumed to be $opening
   * @param array $stack Array used as stack of opened tag elements
***************
*** 220,226 ****
  
  	$pee = preg_replace('|<br />\s*<br />|', "\n\n", $pee);
  	// Space things out a little
! 	$allblocks = '(?:table|thead|tfoot|caption|col|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|option|form|map|area|blockquote|address|math|style|p|h[1-6]|hr|fieldset|noscript|samp|legend|section|article|aside|hgroup|header|footer|nav|figure|figcaption|details|menu|summary)';
  	$pee = preg_replace('!(<' . $allblocks . '[^>]*>)!', "\n$1", $pee);
  	$pee = preg_replace('!(</' . $allblocks . '>)!', "$1\n\n", $pee);
  	$pee = str_replace(array("\r\n", "\r"), "\n", $pee); // cross-platform newlines
--- 220,226 ----
  
  	$pee = preg_replace('|<br />\s*<br />|', "\n\n", $pee);
  	// Space things out a little
! 	$allblocks = '(?:table|thead|tfoot|caption|col|colgroup|tbody|tr|td|th|div|dl|dd|dt|ul|ol|li|pre|select|option|form|map|area|blockquote|address|math|style|p|h[1-6]|hr|fieldset|noscript|legend|section|article|aside|hgroup|header|footer|nav|figure|figcaption|details|menu|summary)';
  	$pee = preg_replace('!(<' . $allblocks . '[^>]*>)!', "\n$1", $pee);
  	$pee = preg_replace('!(</' . $allblocks . '>)!', "$1\n\n", $pee);
  	$pee = str_replace(array("\r\n", "\r"), "\n", $pee); // cross-platform newlines
***************
*** 262,267 ****
--- 262,268 ----
   *
   * @since 3.1.0
   * @access private
+  *
   * @param array $matches preg_replace_callback matches array
   * @return string
   */
***************
*** 363,368 ****
--- 364,370 ----
   * &quot;, or ENT_QUOTES to do both. Default is ENT_NOQUOTES where no quotes are encoded.
   *
   * @since 1.2.2
+  * @access private
   *
   * @param string $string The text which is to be encoded.
   * @param mixed $quote_style Optional. Converts double quotes if set to ENT_COMPAT, both single and double if set to ENT_QUOTES or none if set to ENT_NOQUOTES. Also compatible with old values; converting single quotes if set to 'single', double if set to 'double' or both if otherwise set. Default is ENT_NOQUOTES.
***************
*** 442,448 ****
   * $quote_style can be set to ENT_COMPAT to decode " entities,
   * or ENT_QUOTES to do both " and '. Default is ENT_NOQUOTES where no quotes are decoded.
   *
!  * @since 2.8
   *
   * @param string $string The text which is to be decoded.
   * @param mixed $quote_style Optional. Converts double quotes if set to ENT_COMPAT, both single and double if set to ENT_QUOTES or none if set to ENT_NOQUOTES. Also compatible with old _wp_specialchars() values; converting single quotes if set to 'single', double if set to 'double' or both if otherwise set. Default is ENT_NOQUOTES.
--- 444,450 ----
   * $quote_style can be set to ENT_COMPAT to decode " entities,
   * or ENT_QUOTES to do both " and '. Default is ENT_NOQUOTES where no quotes are decoded.
   *
!  * @since 2.8.0
   *
   * @param string $string The text which is to be decoded.
   * @param mixed $quote_style Optional. Converts double quotes if set to ENT_COMPAT, both single and double if set to ENT_QUOTES or none if set to ENT_NOQUOTES. Also compatible with old _wp_specialchars() values; converting single quotes if set to 'single', double if set to 'double' or both if otherwise set. Default is ENT_NOQUOTES.
***************
*** 499,505 ****
  /**
   * Checks for invalid UTF8 in a string.
   *
!  * @since 2.8
   *
   * @param string $string The text which is to be checked.
   * @param boolean $strip Optional. Whether to attempt to strip out invalid UTF8. Default is false.
--- 501,507 ----
  /**
   * Checks for invalid UTF8 in a string.
   *
!  * @since 2.8.0
   *
   * @param string $string The text which is to be checked.
   * @param boolean $strip Optional. Whether to attempt to strip out invalid UTF8. Default is false.
***************
*** 785,790 ****
--- 787,805 ----
  		chr(199).chr(155) => 'U', chr(199).chr(156) => 'u',
  		);
  
+ 		// Used for locale-specific rules
+ 		$locale = get_locale();
+ 
+ 		if ( 'de_DE' == $locale ) {
+ 			$chars[ chr(195).chr(132) ] = 'Ae';
+ 			$chars[ chr(195).chr(164) ] = 'ae';
+ 			$chars[ chr(195).chr(150) ] = 'Oe';
+ 			$chars[ chr(195).chr(182) ] = 'oe';
+ 			$chars[ chr(195).chr(156) ] = 'Ue';
+ 			$chars[ chr(195).chr(188) ] = 'ue';
+ 			$chars[ chr(195).chr(159) ] = 'ss';
+ 		}
+ 
  		$string = strtr($string, $chars);
  	} else {
  		// Assume ISO-8859-1 if not UTF-8
***************
*** 811,822 ****
  }
  
  /**
!  * Sanitizes a filename replacing whitespace with dashes
   *
   * Removes special characters that are illegal in filenames on certain
   * operating systems and special characters requiring special escaping
   * to manipulate at the command line. Replaces spaces and consecutive
!  * dashes with a single dash. Trim period, dash and underscore from beginning
   * and end of filename.
   *
   * @since 2.1.0
--- 826,837 ----
  }
  
  /**
!  * Sanitizes a filename, replacing whitespace with dashes.
   *
   * Removes special characters that are illegal in filenames on certain
   * operating systems and special characters requiring special escaping
   * to manipulate at the command line. Replaces spaces and consecutive
!  * dashes with a single dash. Trims period, dash and underscore from beginning
   * and end of filename.
   *
   * @since 2.1.0
***************
*** 868,874 ****
  }
  
  /**
!  * Sanitize username stripping out unsafe characters.
   *
   * Removes tags, octets, entities, and if strict is enabled, will only keep
   * alphanumeric, _, space, ., -, @. After sanitizing, it passes the username,
--- 883,889 ----
  }
  
  /**
!  * Sanitizes a username, stripping out unsafe characters.
   *
   * Removes tags, octets, entities, and if strict is enabled, will only keep
   * alphanumeric, _, space, ., -, @. After sanitizing, it passes the username,
***************
*** 903,909 ****
  }
  
  /**
!  * Sanitize a string key.
   *
   * Keys are used as internal identifiers. Lowercase alphanumeric characters, dashes and underscores are allowed.
   *
--- 918,924 ----
  }
  
  /**
!  * Sanitizes a string key.
   *
   * Keys are used as internal identifiers. Lowercase alphanumeric characters, dashes and underscores are allowed.
   *
***************
*** 920,926 ****
  }
  
  /**
!  * Sanitizes title or use fallback title.
   *
   * Specifically, HTML and PHP tags are stripped. Further actions can be added
   * via the plugin API. If $title is empty and $fallback_title is set, the latter
--- 935,941 ----
  }
  
  /**
!  * Sanitizes a title, or returns a fallback title.
   *
   * Specifically, HTML and PHP tags are stripped. Further actions can be added
   * via the plugin API. If $title is empty and $fallback_title is set, the latter
***************
*** 933,939 ****
   * @param string $context Optional. The operation for which the string is sanitized
   * @return string The sanitized string.
   */
! function sanitize_title($title, $fallback_title = '', $context = 'save') {
  	$raw_title = $title;
  
  	if ( 'save' == $context )
--- 948,954 ----
   * @param string $context Optional. The operation for which the string is sanitized
   * @return string The sanitized string.
   */
! function sanitize_title( $title, $fallback_title = '', $context = 'save' ) {
  	$raw_title = $title;
  
  	if ( 'save' == $context )
***************
*** 947,958 ****
  	return $title;
  }
  
! function sanitize_title_for_query($title) {
! 	return sanitize_title($title, '', 'query');
  }
  
  /**
!  * Sanitizes title, replacing whitespace and a few other characters with dashes.
   *
   * Limits the output to alphanumeric characters, underscore (_) and dash (-).
   * Whitespace becomes a dash.
--- 962,984 ----
  	return $title;
  }
  
! /**
!  * Sanitizes a title with the 'query' context.
!  *
!  * Used for querying the database for a value from URL.
!  *
!  * @since 3.1.0
!  * @uses sanitize_title()
!  *
!  * @param string $title The string to be sanitized.
!  * @return string The sanitized string.
!  */
! function sanitize_title_for_query( $title ) {
! 	return sanitize_title( $title, '', 'query' );
  }
  
  /**
!  * Sanitizes a title, replacing whitespace and a few other characters with dashes.
   *
   * Limits the output to alphanumeric characters, underscore (_) and dash (-).
   * Whitespace becomes a dash.
***************
*** 964,970 ****
   * @param string $context Optional. The operation for which the string is sanitized.
   * @return string The sanitized title.
   */
! function sanitize_title_with_dashes($title, $raw_title = '', $context = 'display') {
  	$title = strip_tags($title);
  	// Preserve escaped octets.
  	$title = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '---$1---', $title);
--- 990,996 ----
   * @param string $context Optional. The operation for which the string is sanitized.
   * @return string The sanitized title.
   */
! function sanitize_title_with_dashes( $title, $raw_title = '', $context = 'display' ) {
  	$title = strip_tags($title);
  	// Preserve escaped octets.
  	$title = preg_replace('|%([a-fA-F0-9][a-fA-F0-9])|', '---$1---', $title);
***************
*** 999,1006 ****
  			'%e2%80%9a', '%e2%80%9b', '%e2%80%9e', '%e2%80%9f',
  			// copy, reg, deg, hellip and trade
  			'%c2%a9', '%c2%ae', '%c2%b0', '%e2%80%a6', '%e2%84%a2',
! 			// grave accent, acute accent, macron, caron
! 			'%cc%80', '%cc%81', '%cc%84', '%cc%8c',
  		), '', $title );
  
  		// Convert times to x
--- 1025,1034 ----
  			'%e2%80%9a', '%e2%80%9b', '%e2%80%9e', '%e2%80%9f',
  			// copy, reg, deg, hellip and trade
  			'%c2%a9', '%c2%ae', '%c2%b0', '%e2%80%a6', '%e2%84%a2',
! 			// acute accents
! 			'%c2%b4', '%cb%8a', '%cc%81', '%cd%81',
! 			// grave accent, macron, caron
! 			'%cc%80', '%cc%84', '%cc%8c',
  		), '', $title );
  
  		// Convert times to x
***************
*** 1034,1040 ****
  }
  
  /**
!  * Santizes a html classname to ensure it only contains valid characters
   *
   * Strips the string down to A-Z,a-z,0-9,_,-. If this results in an empty
   * string then it will return the alternative value supplied.
--- 1062,1068 ----
  }
  
  /**
!  * Sanitizes an HTML classname to ensure it only contains valid characters.
   *
   * Strips the string down to A-Z,a-z,0-9,_,-. If this results in an empty
   * string then it will return the alternative value supplied.
***************
*** 1132,1140 ****
  }
  
  /**
!  * Will only balance the tags if forced to and the option is set to balance tags.
!  *
!  * The option 'use_balanceTags' is used to determine whether the tags will be balanced.
   *
   * @since 0.71
   *
--- 1160,1166 ----
  }
  
  /**
!  * Balances tags if forced to, or if the 'use_balanceTags' option is set to true.
   *
   * @since 0.71
   *
***************
*** 1143,1151 ****
   * @return string Balanced text
   */
  function balanceTags( $text, $force = false ) {
! 	if ( !$force && get_option('use_balanceTags') == 0 )
  		return $text;
- 	return force_balance_tags( $text );
  }
  
  /**
--- 1169,1178 ----
   * @return string Balanced text
   */
  function balanceTags( $text, $force = false ) {
! 	if ( $force || get_option('use_balanceTags') == 1 )
! 		return force_balance_tags( $text );
! 	else
  		return $text;
  }
  
  /**
***************
*** 1342,1350 ****
   * @return string String with backslashes inserted.
   */
  function backslashit($string) {
! 	$string = preg_replace('/^([0-9])/', '\\\\\\\\\1', $string);
! 	$string = preg_replace('/([a-z])/i', '\\\\\1', $string);
! 	return $string;
  }
  
  /**
--- 1369,1377 ----
   * @return string String with backslashes inserted.
   */
  function backslashit($string) {
! 	if ( isset( $string[0] ) && $string[0] >= '0' && $string[0] <= '9' )
! 		$string = '\\\\' . $string;
! 	return addcslashes( $string, 'A..Za..z' );
  }
  
  /**
***************
*** 1396,1402 ****
  	if ( get_magic_quotes_gpc() )
  		$gpc = stripslashes($gpc);
  
! 	return esc_sql($gpc);
  }
  
  /**
--- 1423,1429 ----
  	if ( get_magic_quotes_gpc() )
  		$gpc = stripslashes($gpc);
  
! 	return wp_slash($gpc);
  }
  
  /**
***************
*** 1692,1703 ****
  	// This is a pre save filter, so text is already escaped.
  	$text = stripslashes($text);
  	$text = preg_replace_callback('|<a (.+?)>|i', 'wp_rel_nofollow_callback', $text);
! 	$text = esc_sql($text);
  	return $text;
  }
  
  /**
!  * Callback to used to add rel=nofollow string to HTML A element.
   *
   * Will remove already existing rel="nofollow" and rel='nofollow' from the
   * string to prevent from invalidating (X)HTML.
--- 1719,1730 ----
  	// This is a pre save filter, so text is already escaped.
  	$text = stripslashes($text);
  	$text = preg_replace_callback('|<a (.+?)>|i', 'wp_rel_nofollow_callback', $text);
! 	$text = wp_slash($text);
  	return $text;
  }
  
  /**
!  * Callback to add rel=nofollow string to HTML A element.
   *
   * Will remove already existing rel="nofollow" and rel='nofollow' from the
   * string to prevent from invalidating (X)HTML.
***************
*** 1868,1873 ****
--- 1895,1901 ----
   *
   * @since 3.1.0
   * @access private
+  *
   * @param array $match The preg_replace_callback matches array
   * @return array Converted chars
   */
***************
*** 1878,1916 ****
  /**
   * Returns a date in the GMT equivalent.
   *
!  * Requires and returns a date in the Y-m-d H:i:s format. Simply subtracts the
!  * value of the 'gmt_offset' option. Return format can be overridden using the
!  * $format parameter. The DateTime and DateTimeZone classes are used to respect
!  * time zone differences in DST.
   *
   * @since 1.2.0
   *
!  * @uses get_option() to retrieve the the value of 'gmt_offset'.
   * @param string $string The date to be converted.
   * @param string $format The format string for the returned date (default is Y-m-d H:i:s)
   * @return string GMT version of the date provided.
   */
! function get_gmt_from_date($string, $format = 'Y-m-d H:i:s') {
! 	preg_match('#([0-9]{1,4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})#', $string, $matches);
! 	if ( ! $matches )
! 		return date( $format, 0 );
! 
! 	$tz = get_option('timezone_string');
  	if ( $tz ) {
! 		date_default_timezone_set( $tz );
! 		$datetime = date_create( $string );
  		if ( ! $datetime )
! 			return date( $format, 0 );
! 
! 		$datetime->setTimezone( new DateTimeZone('UTC') );
! 		$offset = $datetime->getOffset();
! 		$datetime->modify( '+' . $offset / HOUR_IN_SECONDS . ' hours');
! 		$string_gmt = gmdate($format, $datetime->format('U'));
! 
! 		date_default_timezone_set('UTC');
  	} else {
! 		$string_time = gmmktime($matches[4], $matches[5], $matches[6], $matches[2], $matches[3], $matches[1]);
! 		$string_gmt = gmdate($format, $string_time - get_option('gmt_offset') * HOUR_IN_SECONDS);
  	}
  	return $string_gmt;
  }
--- 1906,1936 ----
  /**
   * Returns a date in the GMT equivalent.
   *
!  * Requires and returns a date in the Y-m-d H:i:s format. If there is a
!  * timezone_string available, the date is assumed to be in that timezone,
!  * otherwise it simply subtracts the value of the 'gmt_offset' option. Return
!  * format can be overridden using the $format parameter.
   *
   * @since 1.2.0
   *
!  * @uses get_option() to retrieve the value of 'gmt_offset'.
   * @param string $string The date to be converted.
   * @param string $format The format string for the returned date (default is Y-m-d H:i:s)
   * @return string GMT version of the date provided.
   */
! function get_gmt_from_date( $string, $format = 'Y-m-d H:i:s' ) {
! 	$tz = get_option( 'timezone_string' );
  	if ( $tz ) {
! 		$datetime = date_create( $string, new DateTimeZone( $tz ) );
  		if ( ! $datetime )
! 			return gmdate( $format, 0 );
! 		$datetime->setTimezone( new DateTimeZone( 'UTC' ) );
! 		$string_gmt = $datetime->format( $format );
  	} else {
! 		if ( ! preg_match( '#([0-9]{1,4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})#', $string, $matches ) )
! 			return gmdate( $format, 0 );
! 		$string_time = gmmktime( $matches[4], $matches[5], $matches[6], $matches[2], $matches[3], $matches[1] );
! 		$string_gmt = gmdate( $format, $string_time - get_option( 'gmt_offset' ) * HOUR_IN_SECONDS );
  	}
  	return $string_gmt;
  }
***************
*** 1918,1936 ****
  /**
   * Converts a GMT date into the correct format for the blog.
   *
!  * Requires and returns in the Y-m-d H:i:s format. Simply adds the value of
!  * gmt_offset.Return format can be overridden using the $format parameter
   *
   * @since 1.2.0
   *
   * @param string $string The date to be converted.
   * @param string $format The format string for the returned date (default is Y-m-d H:i:s)
!  * @return string Formatted date relative to the GMT offset.
   */
! function get_date_from_gmt($string, $format = 'Y-m-d H:i:s') {
! 	preg_match('#([0-9]{1,4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})#', $string, $matches);
! 	$string_time = gmmktime($matches[4], $matches[5], $matches[6], $matches[2], $matches[3], $matches[1]);
! 	$string_localtime = gmdate($format, $string_time + get_option('gmt_offset') * HOUR_IN_SECONDS);
  	return $string_localtime;
  }
  
--- 1938,1968 ----
  /**
   * Converts a GMT date into the correct format for the blog.
   *
!  * Requires and returns a date in the Y-m-d H:i:s format. If there is a
!  * timezone_string available, the returned date is in that timezone, otherwise
!  * it simply adds the value of gmt_offset. Return format can be overridden
!  * using the $format parameter
   *
   * @since 1.2.0
   *
   * @param string $string The date to be converted.
   * @param string $format The format string for the returned date (default is Y-m-d H:i:s)
!  * @return string Formatted date relative to the timezone / GMT offset.
   */
! function get_date_from_gmt( $string, $format = 'Y-m-d H:i:s' ) {
! 	$tz = get_option( 'timezone_string' );
! 	if ( $tz ) {
! 		$datetime = date_create( $string, new DateTimeZone( 'UTC' ) );
! 		if ( ! $datetime )
! 			return date( $format, 0 );
! 		$datetime->setTimezone( new DateTimeZone( $tz ) );
! 		$string_localtime = $datetime->format( $format );
! 	} else {
! 		if ( ! preg_match('#([0-9]{1,4})-([0-9]{1,2})-([0-9]{1,2}) ([0-9]{1,2}):([0-9]{1,2}):([0-9]{1,2})#', $string, $matches) )
! 			return date( $format, 0 );
! 		$string_time = gmmktime( $matches[4], $matches[5], $matches[6], $matches[2], $matches[3], $matches[1] );
! 		$string_localtime = gmdate( $format, $string_time + get_option( 'gmt_offset' ) * HOUR_IN_SECONDS );
! 	}
  	return $string_localtime;
  }
  
***************
*** 2101,2127 ****
  function human_time_diff( $from, $to = '' ) {
  	if ( empty( $to ) )
  		$to = time();
  	$diff = (int) abs( $to - $from );
! 	if ( $diff <= HOUR_IN_SECONDS ) {
  		$mins = round( $diff / MINUTE_IN_SECONDS );
! 		if ( $mins <= 1 ) {
  			$mins = 1;
- 		}
  		/* translators: min=minute */
  		$since = sprintf( _n( '%s min', '%s mins', $mins ), $mins );
! 	} elseif ( ( $diff <= DAY_IN_SECONDS ) && ( $diff > HOUR_IN_SECONDS ) ) {
  		$hours = round( $diff / HOUR_IN_SECONDS );
! 		if ( $hours <= 1 ) {
  			$hours = 1;
- 		}
  		$since = sprintf( _n( '%s hour', '%s hours', $hours ), $hours );
! 	} elseif ( $diff >= DAY_IN_SECONDS ) {
  		$days = round( $diff / DAY_IN_SECONDS );
! 		if ( $days <= 1 ) {
  			$days = 1;
- 		}
  		$since = sprintf( _n( '%s day', '%s days', $days ), $days );
  	}
  	return $since;
  }
  
--- 2133,2174 ----
  function human_time_diff( $from, $to = '' ) {
  	if ( empty( $to ) )
  		$to = time();
+ 
  	$diff = (int) abs( $to - $from );
! 
! 	if ( $diff < HOUR_IN_SECONDS ) {
  		$mins = round( $diff / MINUTE_IN_SECONDS );
! 		if ( $mins <= 1 )
  			$mins = 1;
  		/* translators: min=minute */
  		$since = sprintf( _n( '%s min', '%s mins', $mins ), $mins );
! 	} elseif ( $diff < DAY_IN_SECONDS && $diff >= HOUR_IN_SECONDS ) {
  		$hours = round( $diff / HOUR_IN_SECONDS );
! 		if ( $hours <= 1 )
  			$hours = 1;
  		$since = sprintf( _n( '%s hour', '%s hours', $hours ), $hours );
! 	} elseif ( $diff < WEEK_IN_SECONDS && $diff >= DAY_IN_SECONDS ) {
  		$days = round( $diff / DAY_IN_SECONDS );
! 		if ( $days <= 1 )
  			$days = 1;
  		$since = sprintf( _n( '%s day', '%s days', $days ), $days );
+ 	} elseif ( $diff < 30 * DAY_IN_SECONDS && $diff >= WEEK_IN_SECONDS ) {
+ 		$weeks = round( $diff / WEEK_IN_SECONDS );
+ 		if ( $weeks <= 1 )
+ 			$weeks = 1;
+ 		$since = sprintf( _n( '%s week', '%s weeks', $weeks ), $weeks );
+ 	} elseif ( $diff < YEAR_IN_SECONDS && $diff >= 30 * DAY_IN_SECONDS ) {
+ 		$months = round( $diff / ( 30 * DAY_IN_SECONDS ) );
+ 		if ( $months <= 1 )
+ 			$months = 1;
+ 		$since = sprintf( _n( '%s month', '%s months', $months ), $months );
+ 	} elseif ( $diff >= YEAR_IN_SECONDS ) {
+ 		$years = round( $diff / YEAR_IN_SECONDS );
+ 		if ( $years <= 1 )
+ 			$years = 1;
+ 		$since = sprintf( _n( '%s year', '%s years', $years ), $years );
  	}
+ 
  	return $since;
  }
  
***************
*** 2129,2139 ****
   * Generates an excerpt from the content, if needed.
   *
   * The excerpt word amount will be 55 words and if the amount is greater than
!  * that, then the string ' [...]' will be appended to the excerpt. If the string
   * is less than 55 words, then the content will be returned as is.
   *
   * The 55 word limit can be modified by plugins/themes using the excerpt_length filter
!  * The ' [...]' string can be modified by plugins/themes using the excerpt_more filter
   *
   * @since 1.5.0
   *
--- 2176,2186 ----
   * Generates an excerpt from the content, if needed.
   *
   * The excerpt word amount will be 55 words and if the amount is greater than
!  * that, then the string ' [&hellip;]' will be appended to the excerpt. If the string
   * is less than 55 words, then the content will be returned as is.
   *
   * The 55 word limit can be modified by plugins/themes using the excerpt_length filter
!  * The ' [&hellip;]' string can be modified by plugins/themes using the excerpt_more filter
   *
   * @since 1.5.0
   *
***************
*** 2150,2156 ****
  		$text = apply_filters('the_content', $text);
  		$text = str_replace(']]>', ']]&gt;', $text);
  		$excerpt_length = apply_filters('excerpt_length', 55);
! 		$excerpt_more = apply_filters('excerpt_more', ' ' . '[...]');
  		$text = wp_trim_words( $text, $excerpt_length, $excerpt_more );
  	}
  	return apply_filters('wp_trim_excerpt', $text, $raw_excerpt);
--- 2197,2203 ----
  		$text = apply_filters('the_content', $text);
  		$text = str_replace(']]>', ']]&gt;', $text);
  		$excerpt_length = apply_filters('excerpt_length', 55);
! 		$excerpt_more = apply_filters('excerpt_more', ' ' . '[&hellip;]');
  		$text = wp_trim_words( $text, $excerpt_length, $excerpt_more );
  	}
  	return apply_filters('wp_trim_excerpt', $text, $raw_excerpt);
***************
*** 2167,2173 ****
   *
   * @param string $text Text to trim.
   * @param int $num_words Number of words. Default 55.
!  * @param string $more What to append if $text needs to be trimmed. Default '&hellip;'.
   * @return string Trimmed text.
   */
  function wp_trim_words( $text, $num_words = 55, $more = null ) {
--- 2214,2220 ----
   *
   * @param string $text Text to trim.
   * @param int $num_words Number of words. Default 55.
!  * @param string $more Optional. What to append if $text needs to be trimmed. Default '&hellip;'.
   * @return string Trimmed text.
   */
  function wp_trim_words( $text, $num_words = 55, $more = null ) {
***************
*** 2214,2220 ****
  	$to_ncr = array(
  		'&quot;' => '&#34;',
  		'&amp;' => '&#38;',
- 		'&frasl;' => '&#47;',
  		'&lt;' => '&#60;',
  		'&gt;' => '&#62;',
  		'|' => '&#124;',
--- 2261,2266 ----
***************
*** 2491,2497 ****
  
  	$output = convert_chars($text);
  	$output = wpautop($output);
! 	$output = htmlspecialchars($output, ENT_NOQUOTES);
  
  	return apply_filters('richedit_pre', $output);
  }
--- 2537,2543 ----
  
  	$output = convert_chars($text);
  	$output = wpautop($output);
! 	$output = htmlspecialchars($output, ENT_NOQUOTES, get_option( 'blog_charset' ) );
  
  	return apply_filters('richedit_pre', $output);
  }
***************
*** 2509,2515 ****
   */
  function wp_htmledit_pre($output) {
  	if ( !empty($output) )
! 		$output = htmlspecialchars($output, ENT_NOQUOTES); // convert only < > &
  
  	return apply_filters('htmledit_pre', $output);
  }
--- 2555,2561 ----
   */
  function wp_htmledit_pre($output) {
  	if ( !empty($output) )
! 		$output = htmlspecialchars($output, ENT_NOQUOTES, get_option( 'blog_charset' ) ); // convert only < > &
  
  	return apply_filters('htmledit_pre', $output);
  }
***************
*** 2545,2561 ****
  }
  
  /**
!  * Escapes data for use in a MySQL query
   *
!  * This is just a handy shortcut for $wpdb->escape(), for completeness' sake
   *
   * @since 2.8.0
!  * @param string $sql Unescaped SQL data
!  * @return string The cleaned $sql
   */
! function esc_sql( $sql ) {
  	global $wpdb;
! 	return $wpdb->escape( $sql );
  }
  
  /**
--- 2591,2609 ----
  }
  
  /**
!  * Escapes data for use in a MySQL query.
   *
!  * Usually you should prepare queries using wpdb::prepare().
!  * Sometimes, spot-escaping is required or useful. One example
!  * is preparing an array for use in an IN clause.
   *
   * @since 2.8.0
!  * @param string $data Unescaped data
!  * @return string Escaped data
   */
! function esc_sql( $data ) {
  	global $wpdb;
! 	return $wpdb->_escape( $data );
  }
  
  /**
***************
*** 2599,2609 ****
  		$url = str_replace( "'", '&#039;', $url );
  	}
  
! 	if ( ! is_array( $protocols ) )
! 		$protocols = wp_allowed_protocols();
! 	$good_protocol_url = wp_kses_bad_protocol( $url, $protocols );
! 	if ( strtolower( $good_protocol_url ) != strtolower( $url ) )
! 		return '';
  
  	return apply_filters('clean_url', $good_protocol_url, $original_url, $_context);
  }
--- 2647,2661 ----
  		$url = str_replace( "'", '&#039;', $url );
  	}
  
! 	if ( '/' === $url[0] ) {
! 		$good_protocol_url = $url;
! 	} else {
! 		if ( ! is_array( $protocols ) )
! 			$protocols = wp_allowed_protocols();
! 		$good_protocol_url = wp_kses_bad_protocol( $url, $protocols );
! 		if ( strtolower( $good_protocol_url ) != strtolower( $url ) )
! 			return '';
! 	}
  
  	return apply_filters('clean_url', $good_protocol_url, $original_url, $_context);
  }
***************
*** 2690,2707 ****
  /**
   * Escaping for textarea values.
   *
!  * @since 3.1
   *
   * @param string $text
   * @return string
   */
  function esc_textarea( $text ) {
! 	$safe_text = htmlspecialchars( $text, ENT_QUOTES );
  	return apply_filters( 'esc_textarea', $safe_text, $text );
  }
  
  /**
!  * Escape a HTML tag name.
   *
   * @since 2.5.0
   *
--- 2742,2759 ----
  /**
   * Escaping for textarea values.
   *
!  * @since 3.1.0
   *
   * @param string $text
   * @return string
   */
  function esc_textarea( $text ) {
! 	$safe_text = htmlspecialchars( $text, ENT_QUOTES, get_option( 'blog_charset' ) );
  	return apply_filters( 'esc_textarea', $safe_text, $text );
  }
  
  /**
!  * Escape an HTML tag name.
   *
   * @since 2.5.0
   *
***************
*** 2976,2982 ****
   * @return string The formatted string.
   */
  function wp_sprintf( $pattern ) {
! 	$args = func_get_args( );
  	$len = strlen($pattern);
  	$start = 0;
  	$result = '';
--- 3028,3034 ----
   * @return string The formatted string.
   */
  function wp_sprintf( $pattern ) {
! 	$args = func_get_args();
  	$len = strlen($pattern);
  	$start = 0;
  	$result = '';
***************
*** 3085,3100 ****
   *
   * @since 2.5.0
   *
!  * @param integer $str String to get the excerpt from.
   * @param integer $count Maximum number of characters to take.
   * @return string The excerpt.
   */
! function wp_html_excerpt( $str, $count ) {
  	$str = wp_strip_all_tags( $str, true );
! 	$str = mb_substr( $str, 0, $count );
  	// remove part of an entity at the end
! 	$str = preg_replace( '/&[^;\s]{0,6}$/', '', $str );
! 	return $str;
  }
  
  /**
--- 3137,3157 ----
   *
   * @since 2.5.0
   *
!  * @param string $str String to get the excerpt from.
   * @param integer $count Maximum number of characters to take.
+  * @param string $more Optional. What to append if $str needs to be trimmed. Defaults to empty string.
   * @return string The excerpt.
   */
! function wp_html_excerpt( $str, $count, $more = null ) {
! 	if ( null === $more )
! 		$more = '';
  	$str = wp_strip_all_tags( $str, true );
! 	$excerpt = mb_substr( $str, 0, $count );
  	// remove part of an entity at the end
! 	$excerpt = preg_replace( '/&[^;\s]{0,6}$/', '', $excerpt );
! 	if ( $str != $excerpt )
! 		$excerpt = trim( $excerpt ) . $more;
! 	return $excerpt;
  }
  
  /**
***************
*** 3170,3183 ****
  function _links_add_target( $m ) {
  	global $_links_add_target;
  	$tag = $m[1];
! 	$link = preg_replace('|(target=[\'"](.*?)[\'"])|i', '', $m[2]);
  	return '<' . $tag . $link . ' target="' . esc_attr( $_links_add_target ) . '">';
  }
  
! // normalize EOL characters and strip duplicate whitespace
  function normalize_whitespace( $str ) {
! 	$str  = trim($str);
! 	$str  = str_replace("\r", "\n", $str);
  	$str  = preg_replace( array( '/\n+/', '/[ \t]+/' ), array( "\n", ' ' ), $str );
  	return $str;
  }
--- 3227,3247 ----
  function _links_add_target( $m ) {
  	global $_links_add_target;
  	$tag = $m[1];
! 	$link = preg_replace('|(target=([\'"])(.*?)\2)|i', '', $m[2]);
  	return '<' . $tag . $link . ' target="' . esc_attr( $_links_add_target ) . '">';
  }
  
! /**
!  * Normalize EOL characters and strip duplicate whitespace.
!  *
!  * @since 2.7.0
!  *
!  * @param string $str The string to normalize.
!  * @return string The normalized string.
!  */
  function normalize_whitespace( $str ) {
! 	$str  = trim( $str );
! 	$str  = str_replace( "\r", "\n", $str );
  	$str  = preg_replace( array( '/\n+/', '/[ \t]+/' ), array( "\n", ' ' ), $str );
  	return $str;
  }
***************
*** 3226,3232 ****
  		$filtered = trim( preg_replace('/[\r\n\t ]+/', ' ', $filtered) );
  	}
  
- 	$match = array();
  	$found = false;
  	while ( preg_match('/%[a-f0-9]{2}/i', $filtered, $match) ) {
  		$filtered = str_replace($match[0], '', $filtered);
--- 3290,3295 ----
